/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the MfaMethodSettings type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MfaMethodSettings{}

// MfaMethodSettings struct for MfaMethodSettings
type MfaMethodSettings struct {
	Enabled                *bool          `json:"enabled,omitempty"`
	InitializationRequired *bool          `json:"initialization_required,omitempty"`
	CredentialId           NullableString `json:"credential_id,omitempty"`
	Preferred              *bool          `json:"preferred,omitempty"`
	Text                   NullableString `json:"text,omitempty"`
}

// NewMfaMethodSettings instantiates a new MfaMethodSettings object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMfaMethodSettings() *MfaMethodSettings {
	this := MfaMethodSettings{}
	return &this
}

// NewMfaMethodSettingsWithDefaults instantiates a new MfaMethodSettings object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMfaMethodSettingsWithDefaults() *MfaMethodSettings {
	this := MfaMethodSettings{}
	return &this
}

// GetEnabled returns the Enabled field value if set, zero value otherwise.
func (o *MfaMethodSettings) GetEnabled() bool {
	if o == nil || IsNil(o.Enabled) {
		var ret bool
		return ret
	}
	return *o.Enabled
}

// GetEnabledOk returns a tuple with the Enabled field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MfaMethodSettings) GetEnabledOk() (*bool, bool) {
	if o == nil || IsNil(o.Enabled) {
		return nil, false
	}
	return o.Enabled, true
}

// HasEnabled returns a boolean if a field has been set.
func (o *MfaMethodSettings) HasEnabled() bool {
	if o != nil && !IsNil(o.Enabled) {
		return true
	}

	return false
}

// SetEnabled gets a reference to the given bool and assigns it to the Enabled field.
func (o *MfaMethodSettings) SetEnabled(v bool) {
	o.Enabled = &v
}

// GetInitializationRequired returns the InitializationRequired field value if set, zero value otherwise.
func (o *MfaMethodSettings) GetInitializationRequired() bool {
	if o == nil || IsNil(o.InitializationRequired) {
		var ret bool
		return ret
	}
	return *o.InitializationRequired
}

// GetInitializationRequiredOk returns a tuple with the InitializationRequired field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MfaMethodSettings) GetInitializationRequiredOk() (*bool, bool) {
	if o == nil || IsNil(o.InitializationRequired) {
		return nil, false
	}
	return o.InitializationRequired, true
}

// HasInitializationRequired returns a boolean if a field has been set.
func (o *MfaMethodSettings) HasInitializationRequired() bool {
	if o != nil && !IsNil(o.InitializationRequired) {
		return true
	}

	return false
}

// SetInitializationRequired gets a reference to the given bool and assigns it to the InitializationRequired field.
func (o *MfaMethodSettings) SetInitializationRequired(v bool) {
	o.InitializationRequired = &v
}

// GetCredentialId returns the CredentialId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MfaMethodSettings) GetCredentialId() string {
	if o == nil || IsNil(o.CredentialId.Get()) {
		var ret string
		return ret
	}
	return *o.CredentialId.Get()
}

// GetCredentialIdOk returns a tuple with the CredentialId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MfaMethodSettings) GetCredentialIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.CredentialId.Get(), o.CredentialId.IsSet()
}

// HasCredentialId returns a boolean if a field has been set.
func (o *MfaMethodSettings) HasCredentialId() bool {
	if o != nil && o.CredentialId.IsSet() {
		return true
	}

	return false
}

// SetCredentialId gets a reference to the given NullableString and assigns it to the CredentialId field.
func (o *MfaMethodSettings) SetCredentialId(v string) {
	o.CredentialId.Set(&v)
}

// SetCredentialIdNil sets the value for CredentialId to be an explicit nil
func (o *MfaMethodSettings) SetCredentialIdNil() {
	o.CredentialId.Set(nil)
}

// UnsetCredentialId ensures that no value is present for CredentialId, not even an explicit nil
func (o *MfaMethodSettings) UnsetCredentialId() {
	o.CredentialId.Unset()
}

// GetPreferred returns the Preferred field value if set, zero value otherwise.
func (o *MfaMethodSettings) GetPreferred() bool {
	if o == nil || IsNil(o.Preferred) {
		var ret bool
		return ret
	}
	return *o.Preferred
}

// GetPreferredOk returns a tuple with the Preferred field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MfaMethodSettings) GetPreferredOk() (*bool, bool) {
	if o == nil || IsNil(o.Preferred) {
		return nil, false
	}
	return o.Preferred, true
}

// HasPreferred returns a boolean if a field has been set.
func (o *MfaMethodSettings) HasPreferred() bool {
	if o != nil && !IsNil(o.Preferred) {
		return true
	}

	return false
}

// SetPreferred gets a reference to the given bool and assigns it to the Preferred field.
func (o *MfaMethodSettings) SetPreferred(v bool) {
	o.Preferred = &v
}

// GetText returns the Text field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MfaMethodSettings) GetText() string {
	if o == nil || IsNil(o.Text.Get()) {
		var ret string
		return ret
	}
	return *o.Text.Get()
}

// GetTextOk returns a tuple with the Text field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MfaMethodSettings) GetTextOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Text.Get(), o.Text.IsSet()
}

// HasText returns a boolean if a field has been set.
func (o *MfaMethodSettings) HasText() bool {
	if o != nil && o.Text.IsSet() {
		return true
	}

	return false
}

// SetText gets a reference to the given NullableString and assigns it to the Text field.
func (o *MfaMethodSettings) SetText(v string) {
	o.Text.Set(&v)
}

// SetTextNil sets the value for Text to be an explicit nil
func (o *MfaMethodSettings) SetTextNil() {
	o.Text.Set(nil)
}

// UnsetText ensures that no value is present for Text, not even an explicit nil
func (o *MfaMethodSettings) UnsetText() {
	o.Text.Unset()
}

func (o MfaMethodSettings) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MfaMethodSettings) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Enabled) {
		toSerialize["enabled"] = o.Enabled
	}
	if !IsNil(o.InitializationRequired) {
		toSerialize["initialization_required"] = o.InitializationRequired
	}
	if o.CredentialId.IsSet() {
		toSerialize["credential_id"] = o.CredentialId.Get()
	}
	if !IsNil(o.Preferred) {
		toSerialize["preferred"] = o.Preferred
	}
	if o.Text.IsSet() {
		toSerialize["text"] = o.Text.Get()
	}
	return toSerialize, nil
}

type NullableMfaMethodSettings struct {
	value *MfaMethodSettings
	isSet bool
}

func (v NullableMfaMethodSettings) Get() *MfaMethodSettings {
	return v.value
}

func (v *NullableMfaMethodSettings) Set(val *MfaMethodSettings) {
	v.value = val
	v.isSet = true
}

func (v NullableMfaMethodSettings) IsSet() bool {
	return v.isSet
}

func (v *NullableMfaMethodSettings) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMfaMethodSettings(val *MfaMethodSettings) *NullableMfaMethodSettings {
	return &NullableMfaMethodSettings{value: val, isSet: true}
}

func (v NullableMfaMethodSettings) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMfaMethodSettings) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
